#ifdef __cplusplus
extern "C" {
#endif
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"
#ifdef __cplusplus
}
#endif

#include <lg_slib.h>

static double
constant(name)
char *name;
{
    errno = 0;
    switch (*name) {
    case 'E':
	if (strEQ(name, "EX"))
#ifdef EX
	    return EX;
#else
	    goto not_there;
#endif
	break;
    case 'I':
	if (strEQ(name, "IGN_ALL_CAPS"))
#ifdef IGN_ALL_CAPS
	    return IGN_ALL_CAPS;
#else
	    goto not_there;
#endif
	if (strEQ(name, "IGN_MIX_DIGI"))
#ifdef IGN_MIX_DIGI
	    return IGN_MIX_DIGI;
#else
	    goto not_there;
#endif
	break;
    case 'U':
	if (strEQ(name, "UDR_DISK"))
#ifdef UDR_DISK
	    return UDR_DISK;
#else
	    goto not_there;
#endif
	if (strEQ(name, "UDR_MEMO"))
#ifdef UDR_MEMO
	    return UDR_MEMO;
#else
	    goto not_there;
#endif
	break;
    case 'l':
	if (strEQ(name, "langCZ"))
#ifdef langCZ
	    return langCZ;
#else
	    goto not_there;
#endif
	if (strEQ(name, "langGR"))
#ifdef langGR
	    return langGR;
#else
	    goto not_there;
#endif
	if (strEQ(name, "langSK"))
#ifdef langSK
	    return langSK;
#else
	    goto not_there;
#endif
	if (strEQ(name, "langUK"))
#ifdef langUK
	    return langUK;
#else
	    goto not_there;
#endif
	if (strEQ(name, "langUS"))
#ifdef langUS
	    return langUS;
#else
	    goto not_there;
#endif
	break;
    }
    errno = EINVAL;
    return 0;

not_there:
    errno = ENOENT;
    return 0;
}


char buf[2048] = "";

MODULE = Lspell		PACKAGE = Lspell		

PROTOTYPES: ENABLE

double
constant(name)
	char *		name

# Using PPCODE we return two results as a list, but only on success
void
spell_version()
	PREINIT:
	int engine, version;
	PPCODE:
	if (!spell_version(&engine, &version))
		{
		EXTEND(sp, 2);
		PUSHs(sv_2mortal(newSViv(engine)));
		PUSHs(sv_2mortal(newSViv(version)));
		}

void
spell_code(ide)
	char * ide

# Init returns either 1 on success, or undef
SV *
spell_init()
	CODE:
	ST(0) = sv_newmortal();
	if (spell_init() == 0)
		sv_setnv(ST(0), 1);

void
spell_done()

# We return either the l value, or undef
SV *
spell_open_mdr(lang, fname)
	int lang
	char * fname
	PREINIT:
	int l;
	CODE:
	ST(0) = sv_newmortal();
	l = spell_open_mdr(lang, fname);
	if (l >= 0)
		sv_setnv(ST(0), l);

void
spell_close_mdr(l)
	int l

# For user dictionary, we return either 1 on success, or undef
SV *
spell_open_udr(l, fname)
	int l
	char * fname
	CODE:
	ST(0) = sv_newmortal();
	if (spell_open_udr(l, fname) == 0)
		sv_setnv(ST(0), 1);


void
spell_close_udr(l)
	int l

int
spell_check_wrd(l, word, opt)
	int l
	char * word
	int opt

int
spell_sim_words(l, word, udr)
	int l
	char * word
	int udr
	PREINIT:
	char * p, * q;
	PPCODE:
	/* fprintf(stderr, "Pre-OK: word: %s, l: %d, udr: %d\n", word, l, udr); */
	if (spell_sim_words(l, word, udr, buf, sizeof(buf)) == 0)
		{
		/* fprintf(stderr, "OK\n"); */
		p = q = buf;
		while ((*q != '\0') && ((q - buf) < sizeof(buf)))
			{
			while ((*q != '\0') && ((q - buf) < sizeof(buf)))
				{ q++; }
			EXTEND(sp, 1);
			PUSHs(sv_2mortal(newSVpv(p, q - p)));
			q++;
			p = q;
			}
		}

int
spell_add_udr(l, udr, word, tolower)
	int l
	int udr
	char * word
	int tolower

int
spell_del_udr(l, udr, word)
	int l
	int udr
	char * word

int
spell_num_udr(l, udr)
	int l
	int udr


char *
spell_get_udr(l, udr, n)
	int l
	int udr
	int n

