
use ExtUtils::MakeMaker;

print "\tI'll look around your system for the lspell library ...\n";

my @search_dirs = sort { $b cmp $a } glob('../lspell-* ../lspell* /packages/run/lspell* /packages/share/lspell*');

my ($incdir, $libdir, $dictdir);

for my $dir (@search_dirs) {
	if ( -f "$dir/include/lg_slib.h") {
		$incdir = "$dir/include";
		print "\tFound directory with includes $incdir\n";
		last;
		}
	}

for my $dir (@search_dirs) {
	if ( -f "$dir/lib/liblspell.a") {
		$libdir = "$dir/lib";
		print "\tFound directory with library $libdir\n";
		last;
		}
	}

for my $dir (@search_dirs) {
	if ( -f "$dir/dict/cz.spl") {
		$dictdir = "$dir/dict";
		print "\tFound directory with dictionaries $dictdir\n";
		last;
		}
	}

sub ask {
	my ($text, $answer) = @_;
	my $answer = prompt $text, $answer;
	die "Alright, aborting instalation\n" if $answer eq 'q' or $answer eq '';
	$answer;
	}
my $cont = 'n';
if (defined $incdir and defined $libdir and defined $dictdir)
	{
	$cont = prompt "Do you want to continue with these values?", 'y';

	}
if ($cont ne 'y')
	{
	print "OK, let's figure out (answer 'q' to abort)\n";
	$incdir = ask "Tell me where the lspell include file is:", $incdir;
	$libdir = ask "Tell me where the lspell library is:", $libdir;
	$dictdir = ask "Tell me where the lspell dictionaries are:", $dictdir;
	}

=comment

if ($^O =~ /linux/i)
	{ @LIB_NAMES = qw! slib-lin.a SLIB-LIN.A !; }
elsif ($^O =~ /irix/i)
	{ @LIB_NAMES = qw! slib-sgi.a SLIB-SGI.A !; }
elsif ($^O =~ /solaris/i)
	{ @LIB_NAMES = qw! slib-sol.a SLIB-SOL.A !; }
else
	{ print "*** Supported platforms are Linux, IRIX and Solaris, didn't find any of them\n\taborting\n"; exit; }

=cut

sub MY::processPL
	{
	package MY;
	my $inherited = shift->SUPER::processPL(@_);
	$inherited =~ s/(\$\(PERL\) .* Lspell.pm.PL)/$1 -dDICTDIR=$dictdir/;
	$inherited;
	}

WriteMakefile(
	'NAME'		=> 'Lspell',
	'VERSION_FROM'	=> 'Lspell.pm.PL',
	'PL_FILES'	=> { 'Lspell.pm.PL' => 'Lspell.pm' },
	'PM'		=> { 'Lspell.pm' => '$(INST_LIBDIR)/Lspell.pm' },
	'INC'		=> "-I$incdir",
	'LIBS'		=> "-L$libdir -llspell",
	'XS'		=> { 'Lspell.xs' => 'Lspell.c' },
	'dist'		=> { COMPRESS => 'gzip', SUFFIX => 'gz',
			POSTOP => 'mv $(DISTNAME)-$(VERSION).tar.gz ../' },
	);

__END__

