
use ExtUtils::testlib;

BEGIN { $| = 1; print "1..13\n"; }
END {print "not ok 1\n" unless $::lspell_loaded;}

use Lspell;
print "ok 1\n";

$::lspell_loaded = 1;

my ($engine, $version) = Lspell::spell_version();
print "Engine: $engine, version: $version\n";

print "Creating object, loading default cz dictionary\n";
my $spell = new Lspell(langCZ, 'cz', '/dev/null') or do
	{ print $Lspell::errstr, "not ok 2\n"; exit; };
print "ok 2\n";

print "Matching hotel\n";
$spell->match('hotel') or print 'not ';
print "ok 3\n";

print "Matching xxxx\n";
$spell->match('xxxx') and print 'not ';
print "ok 4\n";

print "Matching krtek\n";
$spell->match('krtek') or print 'not ';
print "ok 5\n";

print "Matching nonczech\n";
$spell->match('nonczech') and print 'not ';
print "ok 6\n";

print "Finding similar words to rana\n";
my @expected = qw( Dana hana Jana kana lana Mana pana tana vana Arna
	Rona Runa rna Rna Rna rahna RNA raba Rada raka rapa rasa ranka
	rana rang rank ran ran ran ran ran ran ran );
$spell->match('rana');
my @list = $spell->similar_words('rana');
### my @list = @expected;

if ("@expected" ne "@list")
	{ print "Expected @expected\nGot @list\nnot "; }
print "ok 7\n";

print "Creating object with local dictionary containing word nonczech\n";
my $localspell = new Lspell(langCZ, 'cz', 'local.spl') or do
	{ print $Lspell::errstr, "not ok 8\n"; exit; };
print "ok 8\n";

print "Matching nonczech\n";
$spell->match('nonczech') or print 'not ';
print "ok 9\n";

print "Adding the localdictionary to the original object\n";
$spell->user_dictionary('local.spl') or print $Lspell::errstr, 'not ';
print "ok 10\n";

print "Matching nonczech\n";
$spell->match('nonczech') or print 'not ';
print "ok 11\n";

print "Closing the user dictionary again\n";
$spell->user_dictionary() or print $Lspell::errstr, 'not ';
print "ok 12\n";

print "Matching nonczech\n";
$spell->match('nonczech') and print 'not ';
print "ok 13\n";

